# The version of Open MPI used
%if 0%{?rhel} == 5
 %global openmpiver 1.4-gcc
%endif
%if 0%{?rhel} == 4
  %global openmpiver 1.2.8-gcc
%endif

# This package needs to be arch dependent, however Koji seems to build it noarch by default.
ExcludeArch:	noarch

# Python arch 
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
# Fortran module directory
%global _fmoddir %{_libdir}/gfortran/modules

Name:		mpiwrappers
Version:	1
Release:	4%{?dist}
Summary:	Environment module wrappers for MPI packages in RHEL
Group:		Development/Libraries
License:	GPL+
Source0:	mpiwrappers.module
Source1:	mpiwrappers.rpmmacro
# This is an architecture specific package consisting only of environment
# module files and directories
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires:	python-devel

Requires:	%{name}-openmpi = %{version}-%{release}

%description
This package provides a compatibility layer with the use of environment modules
for the MPI compilers in RHEL to ease packaging of MPI software in Fedora EPEL.

This package pulls in all compatibility packages.


%package devel
Summary:        Environment module wrappers for MPI packages in RHEL
Group:          Development/Libraries
Requires:       %{name}-openmpi-devel = %{version}-%{release}

%description devel
This package provides a compatibility layer with the use of environment modules
for the MPI compilers in RHEL to ease packaging of MPI software in Fedora EPEL.

This package pulls in all compatibility development packages.

# No wrapper for LAM which is obsolete

# No wrappers for mvapich and mvapich2 that are not available on ppc

%package openmpi
Summary:	Environment module wrapper for Open MPI
Group:		Development/Libraries
Requires:	environment-modules
Requires:	openmpi

%description openmpi
This package provides a compatibility layer with the use of environment modules
for Open MPI to ease packaging of MPI software in Fedora EPEL.


%package openmpi-devel
Summary:        Environment module wrapper for Open MPI
Group:          Development/Libraries
Requires:       %{name}-openmpi = %{version}-%{release}
Requires:	openmpi-devel

%description openmpi-devel
This package provides a compatibility layer with the use of environment modules
for Open MPI to ease packaging of MPI software in Fedora EPEL.


%prep

%build

%install
rm -rf %{buildroot}

# Install RPM macros
mkdir -p %{buildroot}%{_sysconfdir}/rpm
sed "s|@COMPILER@|openmpi|g" < %{SOURCE1} > %{buildroot}%{_sysconfdir}/rpm/macros.openmpi-%{_arch}

# Install module files
mkdir -p %{buildroot}%{_sysconfdir}/modulefiles

# Open MPI
%define cname openmpi
sed "s|@BINDIR@|%{_libdir}/openmpi/%{openmpiver}/bin|g;s|@LIBDIR@|%{_libdir}/openmpi/%{openmpiver}/lib|g;s|@MANDIR@|%{_libdir}/%{openmpiver}/man|g;s|@MPIBINDIR@|%{_libdir}/%{cname}/bin|g;s|@MPISYSCONFIG@|%{_sysconfdir}/%{cname}-%{_arch}/|g;s|@MPIFORTRANMODDIR@|%{_fmoddir}/%{cname}/|g;s|@MPIINCLUDE@|%{_includedir}/%{cname}-%{_arch}/|g;s|@MPILIBDIR@|%{_libdir}/%{cname}/lib/|g;s|@MPIMAN@|%{_mandir}/%{cname}-%{_arch}|g;s|@MPIPYTHONSITEARCH@|%{python_sitearch}/%{cname}/|g;s|@MPICOMPILER@|openmpi-%{_arch}|g;s|@MPISUFFIX@|_openmpi|g" < %{SOURCE0} > %{buildroot}%{_sysconfdir}/modulefiles/openmpi-%{_arch}

# Create the directories to be owned by the packages
mkdir -p %{buildroot}%{_libdir}/openmpi/{bin,lib}
mkdir -p %{buildroot}%{_sysconfdir}/openmpi-%{_arch}
mkdir -p %{buildroot}%{_fmoddir}/openmpi
mkdir -p %{buildroot}%{_includedir}/openmpi-%{_arch}
mkdir -p %{buildroot}%{_mandir}/openmpi-%{_arch}
mkdir -p %{buildroot}%{python_sitearch}/openmpi

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)

%files devel
%defattr(-,root,root,-)

%files openmpi
%defattr(-,root,root,-)
%{_libdir}/openmpi/
%{_sysconfdir}/modulefiles/openmpi-%{_arch}
%{_sysconfdir}/openmpi-%{_arch}/
%{_includedir}/openmpi-%{_arch}/
%{_mandir}/openmpi-%{_arch}
%{python_sitearch}/openmpi/

%files openmpi-devel
%defattr(-,root,root,-)
%{_sysconfdir}/rpm/macros.openmpi-%{_arch}
%{_fmoddir}/openmpi/

%changelog
* Sun Oct 10 2010 Jussi Lehtola <jussilehtola@fedoraproject.org> - 1-4
- Try to make package arch dependent.

* Sat Oct 9 2010 Jussi Lehtola <jussilehtola@fedoraproject.org> - 1-3
- Dropped LAM, branched devel stuff in -devel package.

* Sat Aug 21 2010 Jussi Lehtola <jussilehtola@fedoraproject.org> - 1-2
- Review fixes.

* Sat Aug 15 2009 Jussi Lehtola <jussilehtola@fedoraproject.org> - 1-1
- First release.
